searchData={"items":[{"type":"module","title":"Cuid2Ex","doc":"Implementation of the CUID2 (Collision-resistant Unique IDentifier) algorithm.\n\nCUID2 generates secure, collision-resistant ids optimized for horizontal scaling and performance.\nThe generated ids are URL-safe, contain no special characters, and have a fixed length.","ref":"Cuid2Ex.html"},{"type":"module","title":"Example - Cuid2Ex","doc":"iex> Cuid2Ex.create()\n    \"k0xpkry4lx8tl3qh8vry0f6m\"\n\n    iex> generator = Cuid2Ex.init(length: 32)\n    iex> generator.()\n    \"k0xpkry4lx8tl3qh8vry0f6maabc1234\"","ref":"Cuid2Ex.html#module-example"},{"type":"function","title":"Cuid2Ex.buf_to_big_int/1","doc":"Converts a binary buffer to a big integer.","ref":"Cuid2Ex.html#buf_to_big_int/1"},{"type":"function","title":"Cuid2Ex.create/1","doc":"Creates a new CUID2 string with the given options.\n\nSee `init/1` for available options.","ref":"Cuid2Ex.html#create/1"},{"type":"function","title":"Cuid2Ex.create_counter/1","doc":"Creates a counter function that increments from the given starting count.","ref":"Cuid2Ex.html#create_counter/1"},{"type":"function","title":"Parameters - Cuid2Ex.create_counter/1","doc":"* `count` - Starting count","ref":"Cuid2Ex.html#create_counter/1-parameters"},{"type":"function","title":"Cuid2Ex.create_entropy/3","doc":"Creates entropy string of specified length.","ref":"Cuid2Ex.html#create_entropy/3"},{"type":"function","title":"Parameters - Cuid2Ex.create_entropy/3","doc":"* `length` - The desired length of the entropy string (default: 4)\n  * `random` - Function that returns random float between 0 and 1 (default: `:rand.uniform/0`)\n  * `entropy` - Initial entropy string (default: \"\")","ref":"Cuid2Ex.html#create_entropy/3-parameters"},{"type":"function","title":"Cuid2Ex.create_fingerprint/1","doc":"Creates a fingerprint for the CUID generator using `create_entropy/2` with `@big_length`.","ref":"Cuid2Ex.html#create_fingerprint/1"},{"type":"function","title":"Parameters - Cuid2Ex.create_fingerprint/1","doc":"* `random` - Random number generator function (default: `:rand.uniform/0`)","ref":"Cuid2Ex.html#create_fingerprint/1-parameters"},{"type":"function","title":"Cuid2Ex.cuid?/2","doc":"Validates if a given string is a valid Cuid2Ex.","ref":"Cuid2Ex.html#cuid?/2"},{"type":"function","title":"Options - Cuid2Ex.cuid?/2","doc":"* `:min_length` - Minimum allowed length (default: 2)\n  * `:max_length` - Maximum allowed length (default: 32)","ref":"Cuid2Ex.html#cuid?/2-options"},{"type":"function","title":"Examples - Cuid2Ex.cuid?/2","doc":"iex> Cuid2Ex.cuid?(\"k0xpkry4lx8tl3qh8vry0f6m\")\n    true\n\n    iex> Cuid2Ex.cuid?(\"invalid!\")\n    false","ref":"Cuid2Ex.html#cuid?/2-examples"},{"type":"function","title":"Cuid2Ex.hash/1","doc":"Creates a hash of the input string using SHA3-512 and converts it to base36.\nDrops the first character because it will bias the histogram to the left.","ref":"Cuid2Ex.html#hash/1"},{"type":"function","title":"Cuid2Ex.init/1","doc":"Initializes a CUID generator function with the given options.","ref":"Cuid2Ex.html#init/1"},{"type":"function","title":"Options - Cuid2Ex.init/1","doc":"* `:length` - Length of generated ids (default: 24)\n  * `:random` - Custom random number generator function\n  * `:counter` - Custom counter function\n  * `:fingerprint` - Custom fingerprint string\n\nReturns a function that generates CUID2 strings when called.","ref":"Cuid2Ex.html#init/1-options"},{"type":"function","title":"Cuid2Ex.sha3_512/1","doc":"Computes SHA3-512 hash of input and returns it as a big integer.","ref":"Cuid2Ex.html#sha3_512/1"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}